/* ==================================================================== */
/* Template toolbox_skeleton */
/* This file is released under the 3-clause BSD license. See COPYING-BSD. */
/* ==================================================================== */
#include "nq_solver.h"
/* ==================================================================== */
#include<iostream>
using namespace std;
/** this is the size of chess board */
#define N 8
/** Given a completed board, this prints it to the stdout*/
	void print_solution(int state[N][N])
	{
	int i,j;
	
	for(i=0; i<N; ++i)
	{
	for(j=0; j<N; ++j)
	cout<<state[i][j]<<" ";
	cout<<endl;
	}
	cout<<endl;
	}
	 
/** return true if placing a queen on [row][col] is acceptable
	else return false */
	bool accept(int state[N][N], int row, int col)
	{
	int i,j;
	 
	/* check the column */
	for (i=0; i<N; ++i)
	{
	if (state[row][i])
	return false;
	}
	 
	/* check the row */
	for (i=0; i<N; ++i)
	{
	if (state[i][col])
	return false;
	}
	 
/* check the upper left diagnol */
	for (i = row, j = col; i >= 0 && j >= 0; i--, j--)
	{
	if (state[i][j])
	return false;
	}
	 
	/* check the lower left diagnol */
	for (i = row, j = col; i < N && j >= 0; ++i, --j)
	{
	if (state[i][j])
	return false;
	}
	 
	/* check the upper right diagnol */
	for (i = row, j = col; i >= 0 && j < N; i--, ++j)
	{
	if (state[i][j])
	return false;
	}
	 
/* check the lower right diagnol */
	for (i = row, j = col; i < N && j < N; ++i, ++j)
	{
	if (state[i][j])
	return false;
	}
	 
/* return true if all tests passed */
	return true;
	}
	 
	void solve_state(int state[N][N], int row)
	{
	int i;
	 
/* if all queens have been placed at non conflicting positions */
	if (row == N)
	{
	print_solution(state);
	return;
	}
	 
/* Place queens on all positions in a given row and
	check if the state is acceptable
	Continue the process till all possibilities found */
	for(i=0; i<N; ++i)
	{
	if(accept(state, row, i))
	{
	state[row][i] = 1;
	solve_state(state, row+1);
	}
	state[row][i] = 0;
	}
	}
	 
	int main()
	{
	int N;
	std::cout<<"\nEnter an even number.  ";
	std::cin>>N;
	/* initialise the board */
	int state[N][N] = {0};
	 
	solve_state (state, 0);
	 
	return 0;
	}
/* ==================================================================== */
